import axios from 'axios'
// import { MessageBox } from 'element-ui'
// import router from '../router.js'
import {
	jsonToParams
} from './network.config'
if (process.env.ENV === 'production') {
	axios.defaults.baseURL = '' // 接口省去api
	// axios.defaults.baseURL = 'https://oxo.chfatech.com/' // 接口省去api
}
if (process.env.NODE_ENV === 'development') {
	axios.defaults.baseURL = '' // 接口省去api
	// axios.defaults.baseURL = 'http://42.159.84.152/' // 接口省去api
}
// let flag = 0
// axios.defaults.baseURL = 'http://42.159.84.152/new' // 接口省去api
function downLoadPost(url, data, auth = true, options = {
	'responseType': 'blob'
}) {
	let config = {}

	if (auth) {
		config = Object.assign(options, {
			headers: {
				'Authorization': localStorage.getItem('token'),
				'platform': 'app'
			},
		})
	}
	return axios.post(url, data, config)
		.then((res) => responseHandler2(res, options.loading))
		.catch((err) => responseError(err, options.loading))
}

function upLoadPost(url, data, auth = true, options = {
	'Content-Type': 'multipart/form-data'
}) {
	let config = {}

	if (auth) {
		config = Object.assign(options, {
			headers: {
				'Authorization': localStorage.getItem('token'),
				'platform': 'app'
			}
		})
	}
	return axios.post(url, data, config)
		.then((res) => responseHandler2(res, options.loading))
		.catch((err) => responseError(err, options.loading))
}

function downLoadGet(url, auth = true, options = {
	'responseType': 'blob'
}) {
	let config = {}
	if (auth) {
		config = Object.assign(options, {
			headers: {
				'Authorization': localStorage.getItem('token'),
				'platform': 'app'
			}
		})
	}
	return axios.get(url, config, {
			'responseType': 'blob'
		})
		.then((res) => responseHandler2(res, options.loading))
		.catch((err) => responseError(err, options.loading))
}

function get(url, data, auth = true, options = {}) {
	let config = {}
	url = url + jsonToParams(data)
	if (auth) {
		config = Object.assign({}, options)
		config.headers = (config.headers) ? config.headers : {}
		config.headers['Authorization'] = localStorage.getItem('token')
		config.headers['platform'] = 'app'
	}
	return axios.get(url, config)
		.then((res) => responseHandler(res, options.loading))
		.catch((err) => responseError(err, options.loading))
}

function post(url, data, auth = true, options = {}) {
	let config = {}
	// token = localStorage.getItem('token')
	if (auth) {
		config = Object.assign(options, {
			headers: {
				'Authorization': localStorage.getItem('token'),
				'platform': 'app'
			}
		})
	}
	return axios.post(url, data, config)
		.then((res) => responseHandler(res, options.loading))
		.catch((err) => responseError(err, options.loading))
}

function deleteOut(url, data, auth = true, options = {}) {
	url = url + jsonToParams(data)
	// token = localStorage.getItem('token')
	let config = {}
	if (auth) {
		config = Object.assign(options, {
			headers: {
				'Authorization': localStorage.getItem('token'),
				'platform': 'app'
			}
		})
	}
	return axios.delete(url, config)
		.then((res) => responseHandler(res))
		.catch((err) => responseError(err))
}

function put(url, data, auth = true, options = {}) {
	// token = localStorage.getItem('token');
	let config = {}
	if (auth) {
		config = Object.assign(options, {
			headers: {
				'Authorization': localStorage.getItem('token'),
				'platform': 'app'
			}
		})
	}
	return axios.put(url, data, config)
		.then((res) => responseHandler(res))
		.catch((err) => responseError(err))
}

function responseHandler2(res) {
	return Promise.resolve(res.data)
}

function responseHandler(res) {
	if (typeof(res.data) === 'string') {
		if (res.data != '') {
			res.data = JSON.parse(res.data)
		}
	}
	return Promise.resolve(res)
}

function responseError(err) {
	return Promise.reject(err)
}
export default {
	upLoadPost,
	downLoadGet,
	downLoadPost,
	get,
	post,
	deleteOut,
	put
}
